/*************************************************************************************************
Dmitri Korotkevitch
24HOP - Data partitioning in VLDB (second edition)

http://aboutsqlserver.com
email: dmitri@aboutsqlserver.com

Regular table - creation script
(SQL Server 2008)
*************************************************************************************************/


set nocount on
set xact_abort on
go

use Partitioning2008
go

--select @@version


if exists
(
	select * 
	from sys.tables t join sys.schemas s on t.schema_id = s.schema_id
	where s.name = 'dbo' and t.name = 'Data2'
)
	drop table dbo.Data2
go


create table dbo.Data2
(
	OrderDate date not null,
	OrderId int not null identity(1,1),
	OrderNum varchar(32) not null,
	LobColumn varchar(max) null,
	Placeholder char(50) null,
)
TEXTIMAGE_ON [FG1]
go

create unique clustered index IDX_Data2_OrderDate_OrderId
on dbo.Data2(OrderDate, OrderId)
on [FG1]
go

declare
	@StartDate datetime = '2012-12-01'

;with N1(C) as (select 0 union all select 0) -- 2 rows
,N2(C) as (select 0 from N1 as T1 cross join N1 as T2) -- 4 rows
,N3(C) as (select 0 from N2 as T1 cross join N2 as T2) -- 16 rows
,N4(C) as (select 0 from N3 as T1 cross join N3 as T2 cross join N2 as T3) -- 1024 rows
,N5(C) as (select 0 from N4 as T1 cross join N4 ) -- 1,048,576 rows
,IDs(ID) as (select ROW_NUMBER() over (order by (select NULL)) from N5)
insert into dbo.Data2(OrderDate, OrderNum)
	select 
		dateadd(day,ID % 256,@StartDate), 
		'Order: ' + convert(varchar(12),dateadd(day,ID % 256,@StartDate)) + '-' + convert(varchar(12),Id)
	from IDs 
go

select count(*) from dbo.Data2 with (nolock)
go

 -- 1048576