/*************************************************************************************************
Dmitri Korotkevitch
24HOP - Data partitioning in VLDB (second edition)

http://aboutsqlserver.com
email: dmitri@aboutsqlserver.com

Partitioned Table - helpers
(SQL Server 2012)
*************************************************************************************************/


set nocount on
set xact_abort on
go

use Partitioning2012
go

select * from sys.dm_tran_locks where resource_type= 'object'
go

select count(*) from dbo.Data1 with (nolock)
go


select 
	p.partition_number
	,object_name(object_id) as Name
	,filegroup_name(data_space_id) as FileGroup
	,type_desc
from 
	sys.partitions p join sys.allocation_units a on 
		p.partition_id = a.container_id
where 
	object_id = object_id('dbo.Data1')
order by 
	p.partition_number
